﻿using System;
using System.Data;
using System.Data.OleDb;
using System.IO;

namespace XamGridWPFReporting
{
    public class DataSource
    {
        public static DataView DataView
        {
            get { return GetDataView(); }
        }

        private static DataView GetDataView()
        {
            string FileName = @".\data.csv";



            using (OleDbConnection con = new OleDbConnection("Provider=Microsoft.Jet.OleDb.4.0; Data Source = " +
             Path.GetDirectoryName(FileName) +
             "; Extended Properties = \"Text;HDR=YES;FMT=Delimited\""))
            {
                try
                {
                    con.Open();

                    OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM " + Path.GetFileName(FileName), con);


                    DataTable table_temp = new DataTable();
                    da.Fill(table_temp);

                    var view = table_temp.DefaultView;
                    AddRelation(view);

                    return view;
                }
                catch (Exception e)
                {
                    throw e;
                }
                finally
                {
                    if (con.State == ConnectionState.Open)
                        con.Close();

                    //NumberOfCommandsExecuted++;
                }
            }

        }

        private static void AddRelation(DataView view, string parentColumn = "ParentRowNum", string childColumn = "RowNum")
        {
            DataSet dsReportData = new DataSet();

            dsReportData.Tables.Add(view.Table);

            DataColumn obj_ParentClmn2;
            DataColumn obj_ChildClmn2;

            obj_ChildClmn2 = dsReportData.Tables[0].Columns[parentColumn];
            obj_ParentClmn2 = dsReportData.Tables[0].Columns[childColumn];

            DataRelation dtRel = new DataRelation("self_reference", obj_ParentClmn2, obj_ChildClmn2, false);
            dsReportData.Relations.Add(dtRel);

            view.RowFilter = parentColumn + " IS NULL";
        }
    }
}
